from .feloopy import *
from .operators import *

heuristic_algorithms = ['OriginalEP',
                        'LevyEP',
                        'OriginalES',
                        'LevyES',
                        'OriginalMA',
                        'BaseGA',
                        'SingleGA',
                        'MultiGA',
                        'EliteSingleGA',
                        'EliteMultiGA',
                        'BaseDE',
                        'JADE',
                        'SADE',
                        'SHADE',
                        'L_SHADE',
                        'SAP_DE',
                        'OriginalFPA',
                        'OriginalCRO',
                        'OCRO',
                        'OriginalPSO',
                        'PPSO',
                        'HPSO_TVAC',
                        'C_PSO',
                        'CL_PSO',
                        'OriginalBFO',
                        'ABFO',
                        'OriginalBeesA',
                        'ProbBeesA',
                        'OriginalCSO',
                        'OriginalABC',
                        'OriginalACOR',
                        'OriginalCSA',
                        'OriginalFFA',
                        'OriginalFA',
                        'OriginalBA',
                        'AdaptiveBA',
                        'ModifiedBA',
                        'OriginalFOA',
                        'BaseFOA',
                        'WhaleFOA',
                        'OriginalSSpiderO',
                        'OriginalGWO',
                        'RW_GWO',
                        'OriginalSSpiderA',
                        'OriginalALO',
                        'BaseALO',
                        'OriginalMFO',
                        'BaseMFO',
                        'OriginalEHO',
                        'OriginalJA',
                        'BaseJA',
                        'LevyJA',
                        'OriginalWOA',
                        'HI_WOA',
                        'OriginalDO',
                        'OriginalBSA',
                        'OriginalSHO',
                        'OriginalSSO',
                        'OriginalSRSR',
                        'OriginalGOA',
                        'OriginalCOA',
                        'OriginalMSA',
                        'OriginalSLO',
                        'ModifiedSLO',
                        'ImprovedSLO',
                        'OriginalNMRA',
                        'ImprovedNMRA',
                        'OriginalPFA',
                        'OriginalSFO',
                        'ImprovedSFO',
                        'OriginalHHO',
                        'OriginalMRFO',
                        'OriginalBES',
                        'OriginalSSA',
                        'BaseSSA',
                        'OriginalHGS',
                        'OriginalAO',
                        'GWO_WOA',
                        'OriginalMPA',
                        'OriginalHBA',
                        'OriginalSCSO',
                        'OriginalTSO',
                        'OriginalAVOA',
                        'OriginalAGTO',
                        'OriginalARO',
                        'OriginalSA',
                        'OriginalWDO',
                        'OriginalMVO',
                        'BaseMVO',
                        'OriginalTWO',
                        'OppoTWO',
                        'LevyTWO',
                        'EnhancedTWO',
                        'OriginalEFO',
                        'BaseEFO',
                        'OriginalNRO',
                        'OriginalHGSO',
                        'OriginalASO',
                        'OriginalEO',
                        'ModifiedEO',
                        'AdaptiveEO',
                        'OriginalArchOA',
                        'OriginalCA',
                        'OriginalICA',
                        'OriginalTLO',
                        'BaseTLO',
                        'ITLO',
                        'OriginalBSO',
                        'ImprovedBSO',
                        'OriginalQSA',
                        'BaseQSA',
                        'OppoQSA',
                        'LevyQSA',
                        'ImprovedQSA',
                        'OriginalSARO',
                        'BaseSARO',
                        'OriginalLCO',
                        'BaseLCO',
                        'ImprovedLCO',
                        'OriginalSSDO',
                        'OriginalGSKA',
                        'BaseGSKA',
                        'OriginalCHIO',
                        'BaseCHIO',
                        'OriginalFBIO',
                        'BaseFBIO',
                        'OriginalBRO',
                        'BaseBRO',
                        'OriginalSPBO',
                        'DevSPBO',
                        'OriginalDMOA',
                        'DevDMOA',
                        'OriginalIWO',
                        'OriginalBBO',
                        'BaseBBO',
                        'OriginalVCS',
                        'BaseVCS',
                        'OriginalSBO',
                        'BaseSBO',
                        'OriginalEOA',
                        'OriginalWHO',
                        'OriginalSMA',
                        'BaseSMA',
                        'OriginalBMO',
                        'OriginalTSA',
                        'OriginalSOS',
                        'OriginalSOA',
                        'DevSOA',
                        'OriginalGCO',
                        'BaseGCO',
                        'OriginalWCA',
                        'OriginalAEO',
                        'EnhancedAEO',
                        'ModifiedAEO',
                        'ImprovedAEO',
                        'AdaptiveAEO',
                        'OriginalHC',
                        'SwarmHC',
                        'OriginalCEM',
                        'OriginalSCA',
                        'BaseSCA',
                        'OriginalGBO',
                        'OrginalAOA',
                        'OriginalCGO',
                        'OriginalPSS',
                        'OriginalINFO',
                        'OriginalRUN',
                        'OriginalCircleSA',
                        'OriginalHS',
                        'BaseHS'
                        ]

exact_algorithms = [

    # gekko
    ['gekko', 'apopt'],
    ['gekko', 'bpopt'],
    ['gekko', 'ipopt'],

    # ortools
    ['ortools', 'bop'],
    ['ortools', 'cbc'],
    ['ortools', 'clp'],
    ['ortools', 'cplex_'],
    ['ortools', 'cplex'],
    ['ortools', 'glop'],
    ['ortools', 'glpk_'],
    ['ortools', 'glpk'],
    ['ortools', 'gurobi_'],
    ['ortools', 'gurobi'],
    ['ortools', 'sat'],
    ['ortools', 'scip'],
    ['ortools', 'xpress_'],
    ['ortools', 'xpress'],

    # pulp
    ['pulp', 'cbc'],
    ['pulp', 'choco'],
    ['pulp', 'coin'],
    ['pulp', 'coinmp_dll'],
    ['pulp', 'cplex_py'],
    ['pulp', 'cplex'],
    ['pulp', 'glpk'],
    ['pulp', 'gurobi_cmd'],
    ['pulp', 'gurobi'],
    ['pulp', 'highs'],
    ['pulp', 'mipcl'],
    ['pulp', 'mosek'],
    ['pulp', 'pyglpk'],
    ['pulp', 'scip'],
    ['pulp', 'xpress_py'],
    ['pulp', 'xpress'],

    # cvxpy
    ['cvxpy', 'osqp'],
    ['cvxpy', 'ecos'],
    ['cvxpy', 'cvxopt'],
    ['cvxpy', 'scs'],
    ['cvxpy', 'scipy'],
    ['cvxpy', 'glop'],
    ['cvxpy', 'glpk'],
    ['cvxpy', 'glpk_mi'],
    ['cvxpy', 'gurobi'],
    ['cvxpy', 'mosek'],
    ['cvxpy', 'cbc'],
    ['cvxpy', 'cplex'],
    ['cvxpy', 'nag'],
    ['cvxpy', 'pdlp'],
    ['cvxpy', 'scip'],
    ['cvxpy', 'xpress'],
    ['cvxpy', 'copt'],
    ['cvxpy', 'clarabel'],
    ['cvxpy', 'proxqp'],

    # cylp
    ['cylp', 'cbc'],

    # gurobi
    ['gurobi', 'gurobi'],

    # cplex
    ['cplex', 'cplex'],

    # linopy
    ['linopy', 'cbc'],
    ['linopy', 'glpk'],
    ['linopy', 'highs'],
    ['linopy', 'gurobi'],
    ['linopy', 'xpress'],
    ['linopy', 'cplex'],

    # mip
    ['mip', 'cbc'],

    # picos
    ['picos', 'cplex'],
    ['picos', 'cvxopt'],
    ['picos', 'ecos'],
    ['picos', 'glpk'],
    ['picos', 'gurobi'],
    ['picos', 'mosek'],
    ['picos', 'mskfn'],
    ['picos', 'osqp'],
    ['picos', 'scip'],
    ['picos', 'smcp'],

    # pymprog
    ['pymprog', 'glpk'],

    # pyomo
    ['pyomo', 'baron'],
    ['pyomo', 'cbc'],
    ['pyomo', 'conopt'],
    ['pyomo', 'cplex'],
    ['pyomo', 'cplex_direct'],
    ['pyomo', 'cplex_persistent'],
    ['pyomo', 'cyipopt'],
    ['pyomo', 'gams'],
    ['pyomo', 'highs'],
    ['pyomo', 'asl'],
    ['pyomo', 'gdpopt'],
    ['pyomo', 'gdpopt.gloa'],
    ['pyomo', 'gdpopt.lbb'],
    ['pyomo', 'gdpopt.loa'],
    ['pyomo', 'gdpopt.ric'],
    ['pyomo', 'glpk'],
    ['pyomo', 'gurobi'],
    ['pyomo', 'gurobi_direct'],
    ['pyomo', 'gurobi_persistent'],
    ['pyomo', 'ipopt'],
    ['pyomo', 'mindtpy'],
    ['pyomo', 'mosek'],
    ['pyomo', 'mosek_direct'],
    ['pyomo', 'mosek_persistent'],
    ['pyomo', 'mpec_minlp'],
    ['pyomo', 'mpec_nlp'],
    ['pyomo', 'multistart'],
    ['pyomo', 'path'],
    ['pyomo', 'scip'],
    ['pyomo', 'trustregion'],
    ['pyomo', 'xpress'],
    ['pyomo', 'xpress_direct'],
    ['pyomo', 'xpress_persistent'],

    # xpress
    ['xpress', 'xpress'],
]

constraint_algorithms = [

    ['cplex_cp', 'cplex'],
    ['ortools_cp', 'ortools']

]

feloopy_heuristic_algorithms = [
    'GA',
    'SA',
    'TS',
    'DE',
    'GWO'
]
